package S32S33;

import org.omg.CosNaming.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POA;


public class AdviceServer {

    public static void main(String args[]) {
        try{
            ORB orb = ORB.init(args, null);
            POA rootpoa = POAHelper.narrow(orb.resolve_initial_references("RootPOA"));
            rootpoa.the_POAManager().activate();
            // create helper class (defined at the bottom of this file) and register it:
            AdviceImpl helloImpl = new AdviceImpl(); // !!
            org.omg.CORBA.Object ref = rootpoa.servant_to_reference(helloImpl); // !!
            Advice href = AdviceHelper.narrow(ref);
            org.omg.CORBA.Object objRef =
                orb.resolve_initial_references("NameService");
            NamingContextExt ncRef = NamingContextExtHelper.narrow(objRef);
            String name = "Advice";   // !!
            NameComponent path[] = ncRef.to_name(name);
            ncRef.rebind(path, href);
            System.out.println("AdviceServer started.");
            orb.run();
        } catch (Exception e) {
            System.err.println("AdviceServer error: " + e);
            e.printStackTrace(System.out);
        }
    }
}


class AdviceImpl extends AdvicePOA {
    public String getAdvice() {
        return "Relax - you have been too tense lately.";
    }
}
